LOCATEL .EQU    $19
LOCATEH .EQU    $1A     
TEMPL   .EQU    $1B     
TEMPH   .EQU    $1C     
KEYSTAT .EQU    $1D
SCREENL .EQU    $1E
SCREENH .EQU    $1F
KEYBUFF .EQU    $20 ;-$2F
FROMH   .EQU    $31
FROML   .EQU    $30
TOH     .EQU    $33
TOL     .EQU    $32
COUNTH  .EQU    $35
COUNTL  .EQU    $34
COPYLEN .EQU    $36
SKIP    .EQU    $37
RND     .EQU    RANDOM
;---------------------------------------------------------------------
; MAIN
;---------------------------------------------------------------------  
.ORG    $4000   
;        SEI
;        CLD
;        LDX     #$00
;        TXA
;CL1     STA     $00,X           ;Clear zero page
;        STA     $D400,X         ;Clear ANTIC
;        STA     $C000,X         ;Clear GTIA
;        STA     $E800,X         ;Clear POKEY
;        DEX
;        BNE     CL1
;------------- Clear RAM --------------
        LDY     #$00            ;Clear Ram
        LDA     #$03            ;Start at $0300
        STA     $81
        LDA     #$00
        STA     $80
CL2     LDA     #$00
        STA     ($80),Y         ;Store data
        INY                     ;Next byte
        BNE     CL2             ;Branch if not done page
        INC     $81             ;Next page
        LDA     $81
        CMP     #$40            ;Check if at end of RAM ($3FFF)
        BNE     CL2             ;Branch if not
; DLI
;--------- Set up IRQ vectors ---------
;        LDA     #$03            ;point IRQ vector
;        STA     $0200           ;to BIOS routine
;        LDA     #$FC
;        STA     $0201
;        LDA     #$B8            ;point VBI vector
;        STA     $0202           ;to BIOS routine
;        LDA     #$FC
;        STA     $0203
;        LDA     #$B2            ;point Deferred VBI
;        STA     $0204           ;to BIOS routine
;        LDA     #$FC
;        STA     $0205
;--------------------------------------
        LDA     #$00
        STA     NMIEN           ;Disable DLI
        LDA     #$00
        STA     VDSLST          ;DLI low
        LDA     #$BD
        STA     VDSLST+1        ;DLI high
        LDA     #$C0
        STA     NMIEN           ;Enable DLI
        LDA     #$C8
        STA     SDLSTL          ;Display List low
        LDA     #$BF
        STA     SDLSTH          ;Display List high
        LDA     #$00
        STA     VKYBDF          ;Deferred Keyboard low
        LDA     #$BC
        STA     VKYBDF+1        ;Deferred Keyboard high
        LDA     #$00
        STA     KEYSTAT         ;Keypad buffer depth status
        ;LDA     #$40
        ;STA     IRQEN           ;Deferred Keyboard enable
        ;LDA     #$F8
        ;STA     CHBASE          ;Use ROM character set ($F800-$FBFF)
        LDA     #$A0            ;Use custom character set at $A000 
        STA     CHBASE
        LDA     CHACTL
        ORA     #$02            ;Enable character inverse
        AND     #$FB            ;Orient characters right side up
        STA     CHACTL
        LDA     #$04            ;Enable POT read
        STA     CONSOL
;        LDA     #$03
;        STA     GRACTL          ;Graphics control
;        LDA     #$3E
;        STA     DMACTL          ;DMA control
        LDA     #$10
        STA     LOCATEH
        LDA     #$00
        STA     LOCATEL
